/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : BTN1.C
**     Project   : lab_tone_det
**     Processor : MC56F8006_48_LQFP
**     Beantype  : Button
**     Version   : Bean 01.026, Driver 01.13, CPU db: 3.00.177
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 11/15/2008, 4:35 PM
**     Abstract  :
**          This bean provides service for Buttons with inactivity timer.
**          Method GetVal() return the actual (boolean) status of the button.
**          Returned value 'TRUE' is used for 'pressed button' indication.
**          The value 'FALSE' correspond to 'released button'.
**          OnButton event is called after button pressed.
**          The bean contain button inactivity feature to eliminate multiple-call
**          of  OnButton event due the mechanical oscillations of contacts.
**     Settings  :
**         Bean name                   : BTN1
**         Used pin                    : GPIOB2_ANA2_ANB2_MISO_TIN2_CMP0_OUT
**         Button inactivity           : Disabled
**         Initialization                                      
**           Bean enabled in init.     : yes
**           Events enabled in init    : yes
**     Contents  :
**         GetVal     - byte BTN1_GetVal(bool *Status);
**         Init       - void BTN1_Init(void);
**         ConnectPin - void BTN1_ConnectPin(void);
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE BTN1. */

#include "Events.h"
#include "BTN1.h"
/* Include inherited beans */
#include "Inhr1.h"


static dword Counted;                  /* Counted time */

void Inhr1_OnInterrupt(void)
{
  BTN1_OnButton();                     /* Call event */
}

/*
** ===================================================================
**     Method      :  BTN1_GetVal (bean Button)
**
**     Description :
**         Return actual status of the button.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * Status          - Pointer to current button value.
**                           TRUE - Button is pressed
**                           FALSE - Button is not pressed
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
** ===================================================================
*/
byte BTN1_GetVal(bool *Status)
{
  BTN1_ConnectPin();                   /* Connect the shared pin */
  *Status = !(Inhr1_GetVal());         /* Store status value */
  return ERR_OK;                       /* Return */
}

/*
** ===================================================================
**     Method      :  BTN1_Init (bean Button)
**
**     Description :
**         Initialization of the bean.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void BTN1_Init(void)
{
  Counted=0;
}

/*
** ===================================================================
**     Method      :  BTN1_ConnectPin (bean Button)
**
**     Description :
**         This method reconnects selected pin in this bean. This
**         method is available only for CPU derivatives and
**         peripherals that support runtime pin sharing with other
**         internal on-chip peripherals.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void BTN1_ConnectPin(void)
  ** This method is implemented as macro
*/

/* END BTN1. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.99 [04.17]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
